//
//	Modified Object-oriented Realistic Image Synthesis
//	original coded C language in 1989
//	ported to C++ in 2001
//	(c) Copyright & Programmed 2001,2003 by Nakata H.
//	this code is distributed under GPL
//	$Header: /home/nakata/programs/cg/src/RCS/color.h,v 1.6 2003/07/31 21:00:56 nakata Exp $
//
#ifndef __COLOR_DEFINED
#define __COLOR_DEFINED
class color
{
public:
  double	red, green, blue;

  color( double r = 0.0, double g = 0.0, double b = 0.0 )
  {
    red = r;
    green = g;
    blue = b;
  }

  void assign( double r = 0.0, double g = 0.0, double b = 0.0 )
  {
    red = r;
    green = g;
    blue = b;
  }

  color operator += (color &parameter)
  {
    red += parameter.red;
    green += parameter.green;
    blue += parameter.blue;
    return (*this);
  }

  color operator += (double intensity)
  {
    red += intensity;
    green += intensity;
    blue += intensity;
    return (*this);
  }

  color operator *= (color &parameter)
  {
    red *= parameter.red;
    green *= parameter.green;
    blue *= parameter.blue;
    return (*this);
  }

  color operator *= (double scale)
  {
    red *= scale;
    green *= scale;
    blue *= scale;
    return (*this);
  }
};
#endif // __COLOR_DEFINED
// End Of File	---------------------------------------------------------------
