//
//	Modified Object-oriented Realistic Image Synthesis
//	original coded C language in 1989
//	ported to C++ in 2001
//	(c) Copyright & Programmed 2001,2003,2005 by NAKATA H.
//		webmaster@nakata-jp.org
//	this code is distributed under GPL
//
#include <string.h>
#include "screen.h"

#define	VERSION	"1.1"

extern void	cpg( void );
extern void	raytrace( void );

extern void	read_sld( char *file_name );
extern void	clear_all( void );
static void	usage( const char *cmd_name );

extern screen	scrn;

static char	rcsstring[] ="$Header: /home/nakata/programs/cg/src/RCS/main.cpp,v 1.6 2008/01/20 12:13:46 nakata Exp nakata $";

int	main( int argc, char *argv[] )
{
  int	length;
  char	*filename;

  std::cout << "modified Ray Tracing program Ver." << VERSION << "\n";
  if ( argc != 2 ) {
    usage( argv[0] );
    exit(-1);
  }
  if ( (length = strlen( argv[1] )) < 5 ) {
    std::cerr << "too short file name\n";
    exit(-1);
  }

  if ( strcmp( &(argv[1][length - 4]), ".sld" ) == 0 ) {
    read_sld( argv[1] );
  } else {
    std::cerr << "currently only .sld definition file is available.\n";
    exit(-1);
  }

  if ( strstr( argv[0], "cpg" ) != NULL ) {
    cpg();			// fast mode
  } else {
    raytrace();			// standard mode
  }

  if ( (filename = new char[ length + 1 ]) == NULL ) {
    std::cerr << "allocation failed.\n";
    exit(-1);
  }
  strcpy( filename, argv[1] );
  strcpy( &(filename[length-3]), "bmp" );

  scrn.bmpout( filename );
  delete filename;

  clear_all();

  return (0);
}

static void	usage( const char *cmd_name )
{
  std::cerr << "usage:\t" << cmd_name << " define_file\n";
}
// End Of File	---------------------------------------------------------------
