//
//	Modified Object-oriented Realistic Image Synthesis
//	original coded C language in 1989
//	ported to C++ in 2001
//	(c) Copyright & Programmed 2001,2003 by Nakata H.
//	this code is distributed under GPL
//	$Header: /home/nakata/programs/cg/src/RCS/rectangle.h,v 1.4 2003/07/31 21:00:56 nakata Exp $
//
#ifndef	__rectangel_DEFINED
#define	__rectangle_DEFINED

#include "cpg.h"

class rectangle
{
public:
  double	x_min, x_max, y_min, y_max;

  rectangle( double xmin = 0.0, double xmax = 0.0,
	     double ymin = 0.0, double ymax = 0.0 )
  {
    x_min = xmin;
    x_max = xmax;
    y_min = ymin;
    y_max = ymax;
  }

  void	assign( double xmin = 0.0, double xmax = 0.0,
		double ymin = 0.0, double ymax = 0.0 )
  {
    x_min = xmin;
    x_max = xmax;
    y_min = ymin;
    y_max = ymax;
  }

  void	stretch( vector	vec )
  {
    double	x, y;

    if ( vec.z == 0 ) {
      x = ( vec.x < 0 ) ?  -MAXDOUBLE : MAXDOUBLE;
      y = ( vec.y < 0 ) ?  -MAXDOUBLE : MAXDOUBLE;
    } else {
      x = vec.x / vec.z;
      y = vec.y / vec.z;
    }

    if ( x < x_min ) {
      x_min = x;
    }
    if ( x_max < x ) {
      x_max = x;
    }

    if ( y < y_min ) {
      y_min = y;
    }
    if ( y_max < y ) {
      y_max = y;
    }
  }
};
#endif	// __rectangle_DEFINED
// End Of File	---------------------------------------------------------------
